// stylelint-disable function-disallowed-list

// .modal-open      - body class for killing the scroll
// .modal           - container to scroll within
// .modal-dialog    - positioning shell for the actual modal
// .modal-content   - actual modal w/ bg and corners and stuff


// Container that the modal scrolls within
.modal {
  // scss-docs-start modal-css-vars
  --#{$prefix}modal-zindex: #{$zindex-modal};
  --#{$prefix}modal-width: #{$modal-md};
  --#{$prefix}modal-padding: #{$modal-inner-padding};
  --#{$prefix}modal-margin: #{$modal-dialog-margin};
  --#{$prefix}modal-color: #{$modal-content-color};
  --#{$prefix}modal-bg: #{$modal-content-bg};
  --#{$prefix}modal-border-color: #{$modal-content-border-color};
  --#{$prefix}modal-border-width: #{$modal-content-border-width};
  --#{$prefix}modal-border-radius: #{$modal-content-border-radius};
  --#{$prefix}modal-box-shadow: #{$modal-content-box-shadow-xs};
  --#{$prefix}modal-inner-border-radius: #{$modal-content-inner-border-radius};
  --#{$prefix}modal-header-padding-x: #{$modal-header-padding-x};
  --#{$prefix}modal-header-padding-y: #{$modal-header-padding-y};
  --#{$prefix}modal-header-padding: #{$modal-header-padding}; // Todo in v6: Split this padding into x and y
  --#{$prefix}modal-header-border-color: #{$modal-header-border-color};
  --#{$prefix}modal-header-border-width: #{$modal-header-border-width};
  --#{$prefix}modal-title-line-height: #{$modal-title-line-height};
  --#{$prefix}modal-footer-gap: #{$modal-footer-margin-between};
  --#{$prefix}modal-footer-bg: #{$modal-footer-bg};
  --#{$prefix}modal-footer-border-color: #{$modal-footer-border-color};
  --#{$prefix}modal-footer-border-width: #{$modal-footer-border-width};
  // scss-docs-end modal-css-vars

    position: fixed;
    top: 0;
    left: 0;
    outline: 0;
    width: 100%;
    height: 100%;
    z-index: 1055;
    display: none;
    overflow-x: hidden;
    overflow-y: auto;
}

.modal-dialog {
    margin: 0;
    width: 100%;
    min-height: 100%;
    position: relative;
    pointer-events: none;

    .modal.fade & {
        transition: transform .3s ease-out;
        transform: translate(0, -50px);
    }
    .modal.show & {
        transform: none;
    }

    .modal.modal-static & {
        transform: scale(1.02);
    }

    @include media-breakpoint-up(md) {
        width: auto;
        margin-left: auto;
        margin-right: auto;
        min-height: inherit;
    }
}

.modal-dialog-scrollable {
    height: calc(100% - 0.5rem * 2);

    .modal-content {
        max-height: 100%;
        overflow: hidden;
    }

    .modal-body {
        overflow-y: auto;
    }
}

.modal-dialog-centered {
    display: flex;
    align-items: inherit;

    @include media-breakpoint-up(md) {
        align-items: center;
        min-height: calc(100% - 0.5rem * 2);
    }
}

// Actual modal
.modal-content {
    padding: 0;
    background: white;
    position: relative;
    display: flex;
    flex-direction: column;
    width: 100%;
    color: var(--black);
    pointer-events: auto;
    background-clip: padding-box;
    box-shadow: var(--shadow);
    outline: 0;
    flex-grow: 1;
    border-radius: 0;

    .btn-close {
        top: rem(10);
        right: rem(8);
        position: absolute;
    }

    @include media-breakpoint-up(md) {
        border-radius: rem(20);
        flex-grow: 0;
    }
}

.modal-backdrop {
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    z-index: 1050;
    position: fixed;
    background: rgba(0, 0, 0, 0.5);
}

.modal-header {
    border-bottom: 1px solid #E8E8E8;
    padding: rem(12) rem(48) rem(12) rem(12);
    display: flex;
    flex-direction: column;
    align-items: center;
    position: relative;
    min-height: rem(52);

    @include media-breakpoint-up(md) {
        padding: rem(20) rem(48) rem(10) rem(48);
        justify-content: center;
        border-bottom: none;
    }
}

.modal-title {
    margin: 0;
    font-weight: 400;
    font-size: rem(18);

    small {
        font-size: rem(14);
        color: var(--dark);
    }

    @include media-breakpoint-up(md) {
        font-size: rem(24);
        text-align: center;
    }
}

.modal-intro {
    text-align: center;
    color: var(--gray);
    font-size: rem(14);
    line-height: rem(20);
    margin-bottom: rem(32);
}

.modal-body {
    padding: rem(24) rem(12);
    position: relative;
    flex: 1 1 auto;

    @include media-breakpoint-up(md) {
        padding: rem(24) rem(32);
    }
}

.modal-subtitle {
    font-size: rem(14);
    line-height: rem(20);
    text-align: center;
    margin-top: rem(2);
}

.modal-footer {
    flex-shrink: 0;
    padding: rem(12);

    &--buttons {
        display: grid;
        column-gap: rem(10);
        grid-template-columns: 1fr 1fr;
    }

    &--flex {
        display: flex;
        align-items: center;
        justify-content: space-between;
        row-gap: rem(16);
        column-gap: rem(16);

        > * {
            min-width: rem(180);
        }
    }

    @include media-breakpoint-up(md) {
        padding: 0 rem(32) rem(24) rem(32);
    }
}


// Scale up the modal
@include media-breakpoint-up(sm) {

  .modal {
    --#{$prefix}modal-margin: #{$modal-dialog-margin-y-sm-up};
    --#{$prefix}modal-box-shadow: #{$modal-content-box-shadow-sm-up};
  }

  // Automatically set modal's width for larger viewports
  .modal-dialog {
    max-width: rem(606);
    margin-right: auto;
    margin-left: auto;
  }

  .modal-sm {
    --#{$prefix}modal-width: #{$modal-sm};
  }
}

@include media-breakpoint-up(lg) {
  .modal-lg,
  .modal-xl {
    --#{$prefix}modal-width: #{$modal-lg};
  }
}

@include media-breakpoint-up(xl) {
  .modal-xl {
    --#{$prefix}modal-width: #{$modal-xl};
  }
}

.modal-custom {

    .modal-dialog {
        max-width: rem(700);
    }
}

// scss-docs-start modal-fullscreen-loop
@each $breakpoint in map-keys($grid-breakpoints) {
  $infix: breakpoint-infix($breakpoint, $grid-breakpoints);
  $postfix: if($infix != "", $infix + "-down", "");

  @include media-breakpoint-down($breakpoint) {
    .modal-fullscreen#{$postfix} {
      width: 100vw;
      max-width: none;
      height: 100%;
      margin: 0;

      .modal-content {
        height: 100%;
        border: 0;
        @include border-radius(0);
      }

      .modal-header,
      .modal-footer {
        @include border-radius(0);
      }

      .modal-body {
        overflow-y: auto;
      }
    }
  }
}
// scss-docs-end modal-fullscreen-loop
